#--
# Original code from RubyOnRails (http://www.rubyonrails.com)
#++

require 'facets/core/class/descendents'

class Class

  def remove_descendents
    self.descendents.each do |subclass|
      Object.send(:remove_const, subclass.name) rescue nil
    end
    ObjectSpace.garbage_collect
  end

  alias_method :remove_subclasses, :remove_descendents

end



#  _____         _
# |_   _|__  ___| |_
#   | |/ _ \/ __| __|
#   | |  __/\__ \ |_
#   |_|\___||___/\__|
#
=begin test

  require 'test/unit'

  class TCClass < Test::Unit::TestCase

    class A ; end
    class B < A ; end
    class C < B ; end

    def test_remove_descendents
      assert_nothing_raised { B.remove_descendents }
      # doesn't work despite above; not sure why
      #assert_equal( [B], A.descendents )
    end

  end

=end
